package common.functions.primitive;

/**
 * A functional interface for a function f with signature
 * double f(int s, int t, double d).
 * <br>
 * In PRISM, this interface is mostly used in the context that
 * s is the index of an outgoing state, t is the index of the destination
 * state and d is the probability / rate of the transition from s to t. 
 */
@FunctionalInterface
public interface IntIntDoubleToDoubleFunction
{
	public double apply(int s, int t, double d);
}
